import launch
import launch.actions
import launch.substitutions
import launch_ros.actions
import launch.conditions

def generate_launch_description():
    ld = launch.LaunchDescription()

    ns = launch.actions.DeclareLaunchArgument(
        'ns',
        default_value='/',
        description='Namespace in which to launch nodes')
    ld.add_action(ns)
    
    {% if skillset.resources %}
    {% for res in skillset.resources %}
    {{ res.name }}_initial = launch.actions.DeclareLaunchArgument(
        '{{ res.name }}_initial',
        default_value='{{ res.statemachine.initial }}',
        description='{{ res.name }} initial state'
    )
    ld.add_action({{ res.name }}_initial)
    {% endfor %}
    res_manager = launch_ros.actions.Node(
        package='{{ pkgname }}',
        executable='{{ skillset }}_resource_manager',
        name='{{ skillset }}_resource_manager',
        output="{{ output }}",
        namespace=launch.substitutions.LaunchConfiguration('ns'),
        parameters=[{ {% for res in skillset.resources %}
            '{{ res.name }}_initial': launch.substitutions.LaunchConfiguration('{{ res.name }}_initial'),{% endfor %}
        }]
    )
    ld.add_action(res_manager)
    {% endif %}
    {% if skillset.data %}
    {% for d in skillset.data %}
    {{ d.name }}_topic = launch.actions.DeclareLaunchArgument(
        '{{ d.name }}_topic',
        default_value='data/{{ d.name }}',
        description='{{ d.name }} topic'
    )
    ld.add_action({{ d.name }}_topic)
    {% endfor %}
    data_manager = launch_ros.actions.Node(
        package='{{ pkgname }}',
        executable='{{ skillset }}_data_manager',
        name='{{ skillset }}_data_manager',
        output="{{ output }}",
        namespace=launch.substitutions.LaunchConfiguration('ns'),
        remappings=[{% for d in skillset.data %}
            ('data/{{ d.name }}', launch.substitutions.LaunchConfiguration('{{ d.name }}_topic')),{% endfor %}
        ]
    )
    ld.add_action(data_manager)
    {% endif %}
    {% for sk in skillset.skills %}
    {{ sk }}_manager = launch_ros.actions.Node(
        package='{{ pkgname }}',
        executable='{{ sk }}_{% if mock %}mock_{% endif %}manager.py',
        name='{{ sk }}_manager',
        output="{{ output }}",
        namespace=launch.substitutions.LaunchConfiguration('ns'))
    ld.add_action({{ sk }}_manager)
    {% endfor %}

    return ld
